
class Report
  attr_reader :title, :text
  attr_accessor :formatter

  def initialize(formatter)
    @title = '月次報告'
    @text = ['順調','さいこ〜〜〜']
    @fomatter = formatter
  end

  def output_report
    @fomatter.output_report(@title, @text)
  end
end

class Formatter
  def output_report(title,text)
    raise 'Abstract method called.'
  end
end

class HTMLFormatter < Formatter
  def output_report(title,text)
    puts '<html>'
    puts ' <head>'
    puts ' <meta charset="UTF-8">'
    puts " <title>#{title}</title>"
    puts ' </head>'
    puts ' <body>'
    text.each{|line|
      puts(" <p>#{line}</p>")
    }
    puts ' </body>'
    puts '</html>'
  end
end

report = Report.new(HTMLFormatter.new)
report.output_report

